import { ComponentEnhancer } from "recompose";
export interface AutoURLDataSyncRepository {
}
export interface AutoURLDataSyncProps<Data> {
    readonly data: Data | null | undefined;
    readonly isLoadingData: boolean;
    saveData(): void;
    updateData(data: Partial<Data>): void;
}
/**
 * Automatically sync with current URL by requesting data from server using
 * said URL. This is assuming there is data provided by the server at current
 * URL, e.g. user navigates to /users/1, this will send a GET request to
 * /users/1, which should have a defined backend route that contains the
 * relevant data.
 */
export declare function autoURLDataSync<Data>(): ComponentEnhancer<AutoURLDataSyncProps<Data>, {}>;
//# sourceMappingURL=dataHOC.d.ts.map