"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var enzyme_1 = __importDefault(require("enzyme"));
var react_1 = __importDefault(require("react"));
var react_redux_1 = require("react-redux");
var testUtils_1 = require("testUtils");
var ts_mockito_1 = require("ts-mockito");
var dataHOC_1 = require("./dataHOC");
describe("Auto URL data sync", function () {
    var urlDataSync;
    var TestComponent = testUtils_1.createTestComponent();
    var EnhancedComponent = dataHOC_1.autoURLDataSync()(TestComponent);
    var WrappedElement;
    beforeEach(function () {
        urlDataSync = ts_mockito_1.spy({
            get: function () { return Promise.reject(""); },
            update: function () { return Promise.reject(""); }
        });
        var testStore = testUtils_1.createTestStore(undefined, {
            repository: { urlDataSync: ts_mockito_1.instance(urlDataSync) }
        });
        WrappedElement = (react_1.default.createElement(react_redux_1.Provider, { store: testStore },
            react_1.default.createElement(EnhancedComponent, null)));
    });
    it("Should perform get automatically", function () { return __awaiter(_this, void 0, void 0, function () {
        var data, wrapper, loading1, _a, propData, loading2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    data = { a: 0, b: 1, c: 2 };
                    ts_mockito_1.when(urlDataSync.get()).thenResolve(data);
                    wrapper = enzyme_1.default.mount(WrappedElement);
                    loading1 = wrapper.find(TestComponent).props().isLoadingData;
                    expect(loading1).toBeTruthy();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _b.sent();
                    wrapper.setProps({});
                    _a = wrapper
                        .find(TestComponent)
                        .props(), propData = _a.data, loading2 = _a.isLoadingData;
                    // Then
                    ts_mockito_1.verify(urlDataSync.get()).once();
                    expect(loading2).toBeFalsy();
                    expect(propData).toEqual(data);
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should perform save correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        var data, newData, wrapper, updateData, saveData, loading1, _a, propData, loading2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    data = { a: 0, b: 1, c: 2 };
                    newData = { a: 1, b: 2, c: 3 };
                    ts_mockito_1.when(urlDataSync.get()).thenResolve(data);
                    ts_mockito_1.when(urlDataSync.update(ts_mockito_1.anything())).thenResolve(newData);
                    wrapper = enzyme_1.default.mount(WrappedElement);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _b.sent();
                    wrapper.setProps({});
                    updateData = wrapper.find(TestComponent).props().updateData;
                    updateData(newData);
                    wrapper.setProps({});
                    saveData = wrapper.find(TestComponent).props().saveData;
                    saveData();
                    wrapper.setProps({});
                    loading1 = wrapper.find(TestComponent).props().isLoadingData;
                    expect(loading1).toBeTruthy();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 2:
                    _b.sent();
                    wrapper.setProps({});
                    _a = wrapper
                        .find(TestComponent)
                        .props(), propData = _a.data, loading2 = _a.isLoadingData;
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 3:
                    _b.sent();
                    // Then
                    ts_mockito_1.verify(urlDataSync.get()).once();
                    ts_mockito_1.verify(urlDataSync.update(ts_mockito_1.deepEqual(newData))).once();
                    expect(loading2).toBeFalsy();
                    expect(propData).toEqual(newData);
                    return [2 /*return*/];
            }
        });
    }); });
});
