"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var querystring_1 = __importDefault(require("querystring"));
/** This repository allows synchronization of data with current URL. */
function createURLDataSyncRepository(_a, client) {
    var location = _a.location;
    function urlParams() {
        return __assign({}, querystring_1.default.parse(location.search.slice(1)));
    }
    return {
        get: function () { return client.get(location.pathname, { params: urlParams() }); },
        update: function (newData) {
            return client.patch(location.pathname, newData, { params: urlParams() });
        }
    };
}
exports.createURLDataSyncRepository = createURLDataSyncRepository;
